package com.fastbee.deviceData.api.devlink.service;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSON;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.fastbee.deviceData.api.renke.service.RenkeMetDeviceService;
import com.fastbee.deviceData.mapper.DeviceRealtimedataMeteorologyMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class DevLinkMoistureService {

    @Autowired
    private DevLinkAuthorizationService authorizationService;

    @Autowired
    private DeviceRealtimedataMeteorologyMapper deviceRealtimedataMeteorologyMapper;

    /**
     * 获取设备列表
     */
    public List<?> getMoistureDevice(){
        DevLinkAuthorizationService authorization = new DevLinkAuthorizationService();
        //构建请求体
        HashMap<String, Object> body = new HashMap<>();
        body.put("method","get");
        body.put("path","api/v1/product/device/run_status");
        Map<String,Object> params=new HashMap<>();
        params.put("id","3269");
        body.put("params",params);
        String jsonStr = JSONUtil.toJsonStr(body);
        System.err.println(authorization.getBaseUrl() + authorization.getAuth());
        String result = HttpUtil.post(authorization.getBaseUrl() + authorization.getAuth(), jsonStr);
        System.err.println(result);
        JSONObject jsonObject = JSONUtil.parseObj(result);
        Object data = jsonObject.get("data");
        //获取设备状态
        JSONObject jsonObjectData = JSONUtil.parseObj(data);
        Object status = jsonObjectData.get("status");
        //获取设备属性以及实时数据值
        Object properties = jsonObject.get("properties");
        JSONArray propertiesArray = JSONUtil.parseArray(properties);
        //获取设备各项属性实时数据
        propertiesArray.forEach(p -> {

            Object property = JSONUtil.parseObj(p).get("property");
            JSONObject propertyMap = JSONUtil.parseObj(property);
            //属性名称
            propertyMap.get("name");
            //属性key
            propertyMap.get("key");
            //属性值
            Object value = JSONUtil.parseObj(p).get("value");
            //TODO 属性值历史数据，是否需要
            Object list = JSONUtil.parseObj(p).get("list");
            //TODO 封装所需数据
            deviceRealtimedataMeteorologyMapper.insertDeviceRealtimedataMeteorology(null);

        });

        return null;
    }

    public static void main(String[] args) {
        DevLinkMoistureService service = new DevLinkMoistureService();
        service.getMoistureDevice();
    }
}
